--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

local _, ns = ...
local oUF = ns.oUF
local addonName, addon = ...

local function CreateBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = 0, left = 0, bottom = 0, right = 0}})
		frame:SetBackdropColor(0,0,0,0.75)
	
end
local function CreateHealthBackdrop(frame)
    frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
    frame:SetBackdropColor(0.35,0.1,0.1,0.85)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreatePowerBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0.25,0.25,0.75,0.75)
	frame:SetBackdropBorderColor(0,0,0,1)
end

local function CreateBackdrop(frame)
      frame:SetBackdrop({bgFile = "Interface\\TargetingFrame\\UI-StatusBar"})
		frame:SetBackdropColor(0,0,0,0.75)
		frame:SetBackdropBorderColor(0,0,0,0)
end
local function CreateMoverBackdrop(frame)
   frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
        insets = {top = -2, left = -2, bottom = -2, right = -2}})
		frame:SetBackdropColor(0,0.55,0.95,0.45)
		frame:SetBackdropBorderColor(0,0,0,1)
end
local function HealthWrap(frame)
	local HealthWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		HealthWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		HealthWrapper:SetSize(105,27)
		HealthWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		HealthWrapper:SetBackdropColor(0,0,0,0)
		HealthWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local function PowerWrap(frame)
	local PowerWrapper = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		PowerWrapper:SetPoint("LEFT",frame,"LEFT",-5,0)
		PowerWrapper:SetSize(105,22)
		PowerWrapper:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
		edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\PsychoBorder",
		edgeSize = 16,
		insets = {top = 4, left = 4, bottom = 4, right = 4}})
		PowerWrapper:SetBackdropColor(0,0,0,0)
		PowerWrapper:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
end
local FocusTargetMover = CreateFrame("Frame","FocusTargetDrag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	FocusTargetMover:SetSize(132,55)
	FocusTargetMover:SetPoint("CENTER",UIParent,-435,-35)
	
	FocusTargetMover:SetClampedToScreen(true)
	FocusTargetMover:SetClampRectInsets(0, 0, 0,0)
	
local FocusTargetMoverText  = FocusTargetMover:CreateFontString(nil, "OVERLAY")
	FocusTargetMoverText:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.ttf", 16, "OUTLINE")
	FocusTargetMoverText:SetPoint("CENTER",FocusTargetMover,"CENTER", 0,0); 
	FocusTargetMoverText:SetText("")
	
	local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.FTFrameEnable == true then 
				Inked.db.profile.FTX = 0
				Inked.db.profile.FTY = 0
				local point, relativeTo, relativePoint, xOfs, yOfs = FocusTargetMover:GetPoint(n)
				Inked.db.profile.FTX = xOfs
				Inked.db.profile.FTY = yOfs
				Inked.db.profile.FTPoint = point
				FocusTargetMover:SetMovable(true)
				FocusTargetMover:EnableMouse(true)
				FocusTargetMover:RegisterForDrag("LeftButton")
				FocusTargetMover:SetScript("OnDragStart", FocusTargetMover.StartMoving)
				FocusTargetMover:SetScript("OnDragStop", FocusTargetMover.StopMovingOrSizing)
				FocusTargetMover:SetUserPlaced(true)
				FocusTargetMoverText:SetText("Focus Target")
				CreateMoverBackdrop(FocusTargetMover)
			end
		end	
end	
	---Update Database check
	local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe)

local UnitSpecific = {

	focustarget = function(self)
	
		local FTTargetWidth = 95;
		local FTTargetHeight = 35;
		self:SetSize(FTTargetWidth,FTTargetHeight)

		---------------------------------
		-- Target of Target Neame Text --
		---------------------------------
		if Inked.db.profile.FTShowName == true then
		local NameText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		NameText:SetPoint("TOPLEFT", self, 0,15) -- but anchor to the base element so it doesn't wiggle
		NameText:SetJustifyH("LEFT")
		NameText:SetFont(LSM:Fetch("font", Inked.db.profile.FTNamefont), Inked.db.profile.FTNameFontSize, Inked.db.profile.FTNameOutline)
		NameText:SetWidth(300)
		self:Tag(NameText, "[name]") -- oUF will automagically update it!
		end
		----------------------------------
		-- Target of Target Power Value --
		----------------------------------
		if Inked.db.profile.FTShowPowerPercent == true then
		local PowerText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		PowerText:SetPoint("CENTER", self, 0,-21) -- but anchor to the base element so it doesn't wiggle
		PowerText:SetFont(LSM:Fetch("font", Inked.db.profile.FTPowerfont), Inked.db.profile.FTPowerFontSize, Inked.db.profile.FTPowerOutline)
		self:Tag(PowerText, "[perpp]".." %") -- oUF will automagically update it!
		PowerText:SetAlpha(1)
		end

		-----------------------------------
		-- Target of Target Health Value --
		-----------------------------------
		if Inked.db.profile.FTShowHealthPercent == true then
		local HealthText = self:CreateFontString(nil, "OVERLAY", "TextStatusBarText") -- parent to last child to make sure it's on top
		HealthText:SetPoint("CENTER", self, 0,5) -- but anchor to the base element so it doesn't wiggle
		HealthText:SetFont(LSM:Fetch("font", Inked.db.profile.FTHealthfont), Inked.db.profile.FTHealthFontSize, Inked.db.profile.FTHealthOutline)
		self:Tag(HealthText, "[perhp]".." %") -- oUF will automagically update it!
		end

		-------------------------------------------------------
		-- Target of Target Health and Power Bar Adjustments --
		-------------------------------------------------------

		self.Health:SetHeight(25)
		self.Power:SetHeight(20)


	end, -- End Target of Target
	
}
	

local Shared = function(self, unit)
	-- Shared layout code.
	self:SetScale(Inked.db.profile.FTScale)

	-----------------
	--  Mouse Code --
	-----------------
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)

	self:RegisterForClicks'AnyUp'
	------------------
	--  Health Bars --
	------------------

	local Health = CreateFrame("StatusBar", nil, self, BackdropTemplateMixin and "BackdropTemplate")
	Health:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.FTHealthStatusBar))
	Health:SetPoint('TOP')
	Health:SetPoint('LEFT')
	Health:SetPoint('RIGHT')
	Health:SetFrameLevel(2)
	HealthWrap(Health)
	CreateBackdrop(Health)
	

	-- Options
	--Health.frequentUpdates = true
	Health.colorTapping = true
	Health.colorDisconnected = true
	Health.colorClass = true
	Health.colorReaction = true
	Health.colorHealth = true
	-- Register it with oUF
	self.Health = Health
	self.Health.bg = Healthbg

    -----------------
	--  Power Bars --
	-----------------

	local Power = CreateFrame("StatusBar", nil, Health, BackdropTemplateMixin and "BackdropTemplate")
	Power:SetStatusBarTexture(LSM:Fetch("statusbar", Inked.db.profile.FTPowerStatusBar))
	Power:SetPoint('BOTTOM',Health,'BOTTOM',0,-25)
	Power:SetPoint('LEFT')
	Power:SetPoint('RIGHT')
	Power:SetFrameLevel(1)
	PowerWrap(Power)
	CreateBackdrop(Power)
	
	-- Options
	--Power.frequentUpdates = true
	Power.colorPower = true -- powertype colored bar
	Power.colorClassNPC = false -- color power based on NPC
	Power.colorClassPet = false -- color power based on pet type
	-- Register it with oUF
	self.Power = Power
	self.Power.bg = Powerbg


	-----------------
	-- Smooth Bars --
	-----------------

	self.Health.Smooth = true
		if self.Power then
			self.Power.Smooth = true
		end


	if(UnitSpecific[unit]) then
		return UnitSpecific[unit](self)
	end
end

oUF:RegisterStyle("InkedFocusTarget", Shared)
oUF:Factory(function(self)

	-----------------
	-- Unit Set Up --
	-----------------
	self:SetActiveStyle("InkedFocusTarget")
	--self:Spawn("targettarget"):SetPoint("CENTER",UIParent,"CENTER",235,-335)
	
	if Inked.db.profile.FTPoint == nil then
		 self:Spawn("focustarget"):SetPoint("Center",UIParent,Inked.db.profile.FTX,Inked.db.profile.FTY)
		FocusTargetMover:SetPoint("Center",UIParent,Inked.db.profile.FTX,Inked.db.profile.FTY)
	  else
		 self:Spawn("focustarget"):SetPoint(Inked.db.profile.FTPoint,UIParent,Inked.db.profile.FTX,Inked.db.profile.FTY)
		FocusTargetMover:SetPoint(Inked.db.profile.FTPoint,UIParent,Inked.db.profile.FTX,Inked.db.profile.FTY)
	  end


end)